#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

/* include this first, before NO_IMPORT_PYGOBJECT is defined */
#include <pygobject.h>
#include <pygtk/pygtk.h>
#include <diacanvas/dia-canvas.h>


#if 0
static PyObject *
diacanvasiter_from_value(const GValue *value)
{
	DiaCanvasIter *iter = (DiaCanvasIter*) g_value_get_boxed (value);
	return iter->data[0];
}

static int
diacanvasiter_to_value (GValue *value, PyObject *py_iter)
{
	DiaCanvasIter iter;

	iter.data[0] = py_iter;
	iter.data[1] = NULL;
	iter.data[2] = NULL;
	iter.stamp = 0;

	// Decrement the refcount... The owner item should hold a reference
	// to the iterator item.
	Py_XDECREF (py_iter);
	g_value_set_boxed (value, &iter);

	return 0;
}
#endif

void pydiacanvas_add_constants (PyObject *module, const gchar *strip_prefix);
void pydiacanvas_register_classes (PyObject *d);

extern PyMethodDef pydiacanvas_functions[];

DL_EXPORT(void)
initcanvas (void)
{
	PyObject *m, *d, *tuple;

	/* Standard initialization: */
	init_pygobject ();
	init_pygtk ();

	if (!PyImport_ImportModule("diacanvas.geometry")) {
		Py_FatalError("could not import diacanvas.geometry");
		return;
	}
	if (!PyImport_ImportModule("diacanvas.shape")) {
		Py_FatalError("could not import diacanvas.shape");
		return;
	}
	/* pyg_register_boxed_custom (DIA_TYPE_CANVAS_ITER,
				   diacanvasiter_from_value,
				   diacanvasiter_to_value); */

	m = Py_InitModule ("diacanvas.canvas", pydiacanvas_functions);
	d = PyModule_GetDict (m);

	/* diacanvas2 version */
	tuple = Py_BuildValue ("(iii)", DIACANVAS_MAJOR_VERSION,
				DIACANVAS_MINOR_VERSION,
				DIACANVAS_MICRO_VERSION);
	PyDict_SetItemString(d, "diacanvas_version", tuple);
	Py_DECREF(tuple);

	pydiacanvas_register_classes (d);
	pydiacanvas_add_constants (m, "DIA_");

	if (PyErr_Occurred ()) {
		Py_FatalError ("can't initialise module diacanvas.canvas");
	}
}

